package org.example;

import com.beust.jcommander.JCommander;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.SneakyThrows;
import org.apache.commons.io.IOUtils;
import org.apache.hc.client5.http.classic.methods.HttpPost;
import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.HttpClients;
import org.apache.hc.core5.http.ContentType;
import org.apache.hc.core5.http.Header;
import org.apache.hc.core5.http.io.entity.StringEntity;
import org.apache.hc.core5.http.message.BasicHeader;
import org.example.user.Lyl;
import org.example.user.RequestInfo;
import org.example.user.UserInfo;
import org.example.user.Zyx;

import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Random;

// 10 8,18 * * mon,tue,wed,thu,fri /opt/jdk1.8.0_211/bin/java -jar /home/zyx/jar/app.jar --zyx --lyl
public class Daka {

    private static AliyunLogger logger = new AliyunLogger();

    private static String randomStr() {
        Random random = new Random();
        StringBuilder randomNumber = new StringBuilder();
        for (int i = 0; i < 8; i++) {
            int digit = random.nextInt(10);  // generates a random integer from 0 to 9
            randomNumber.append(digit);
        }
        return randomNumber.toString();
    }


    @SneakyThrows
    public static void main(String[] args) {

        var argv = new Argv();
        JCommander.newBuilder()
                .addObject(argv)
                .build()
                .parse(args);


        String publicKeyStr = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQChDzcjw/rWgFwnxunbKp7/4e8w\n" +
                "/UmXx2jk6qEEn69t6N2R1i/LmcyDT1xr/T2AHGOiXNQ5V8W4iCaaeNawi7aJaRht\n" +
                "Vx1uOH/2U378fscEESEG8XDqll0GCfB1/TjKI2aitVSzXOtRs8kYgGU78f7VmDNg\n" +
                "XIlk3gdhnzh+uoEQywIDAQAB";


        BASE64Encoder encoder = new BASE64Encoder();

        try (CloseableHttpClient client = HttpClients.createDefault()) {

            var arrayList = new ArrayList<UserInfo>();
            if (argv.lyl) {
                arrayList.add(new Lyl());
            }
            if (argv.zyx) {
                arrayList.add(new Zyx());
            }

            for (UserInfo userInfo : arrayList) {
                var requestInfo = userInfo.getRequestInfo();
                byte[] sendTime = RsaUtil.encryptByPublicKey((System.currentTimeMillis() + "").getBytes(), publicKeyStr);
                requestInfo.setSendTime(encoder.encode(sendTime));
                String jsessionid = getLoginCookie(client, requestInfo);
                daka(client, jsessionid);
            }

        }

    }

    @SneakyThrows
    private static void daka(CloseableHttpClient client, String jsessionid) {
        HttpPost httpPost = new HttpPost("http://oa.sxtvs.com/seeyon/rest/lexmisAtt/attCommon/attApi?cmprnd=" + randomStr());

        httpPost.setHeaders(new BasicHeader("Content-Type", "application/json;charset=UTF-8"));
        httpPost.setHeaders(new BasicHeader("User-Agent", "seeyon-m3/4.2.4"));
        httpPost.setHeaders(new BasicHeader("accessm3-scheme", "http"));
        httpPost.setHeaders(new BasicHeader("sendtime", String.valueOf(System.currentTimeMillis() / 1000)));
        httpPost.setHeaders(new BasicHeader("Cookie", jsessionid + ";"));
        DakaRootParams daka = new DakaRootParams();
        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(daka);

        StringEntity entity = new StringEntity(json, ContentType.APPLICATION_JSON);
        httpPost.setEntity(entity);
        String body = client.execute(httpPost, response -> {
            InputStream inputStream = response.getEntity().getContent();
            return IOUtils.toString(inputStream, StandardCharsets.UTF_8);
        });
        logger.info("data", body);
    }

    @SneakyThrows
    private static String getLoginCookie(CloseableHttpClient client, RequestInfo requestInfo) {
        HttpPost httpPost = new HttpPost("http://oa.sxtvs.com/seeyon/rest/m3/login/verification");

        httpPost.setHeaders(new BasicHeader("Content-Type", "application/json;charset=UTF-8"));
        httpPost.setHeaders(new BasicHeader("User-Agent", "seeyon-m3/4.2.4"));
        httpPost.setHeaders(new BasicHeader("accessm3-scheme", "http"));
        httpPost.setHeaders(new BasicHeader("sendtime", String.valueOf(System.currentTimeMillis() / 1000)));
        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(requestInfo);
        StringEntity entity = new StringEntity(json, ContentType.APPLICATION_JSON);
        httpPost.setEntity(entity);

        return client.execute(httpPost, response -> {
//            InputStream inputStream = response.getEntity().getContent();
//            String body = IOUtils.toString(inputStream, StandardCharsets.UTF_8);
            for (Header header : response.getHeaders()) {
                String name = header.getName();
                if ("Set-Cookie".equals(name)) {
                    String value = header.getValue();
                    if (value.startsWith("JSESSIONID")) {
                        return value.split(";")[0];
                    }
                }
            }
            return "";
        });
    }
}
